<link rel="import" href="../../bower_components/polymer/polymer-element.html">
<link rel="import" href="../../bower_components/polymer/lib/elements/dom-if.html">
<link rel="import" href="../../bower_components/paper-dialog/paper-dialog.html">
<link rel="import" href="../../bower_components/paper-button/paper-button.html">
<link rel="import" href="../../bower_components/fotosocial-login/fotosocial-login.html">
<link rel="import" href="../../bower_components/fotosocial-login-dm/fotosocial-login-dm.html">
<link rel="import" href="../../bower_components/fotosocial-register/fotosocial-register.html">
<link rel="import" href="../../bower_components/fotosocial-dashboard/fotosocial-dashboard.html">
<link rel="import" href="../../bower_components/fotosocial-user-register-dm/fotosocial-user-register-dm.html">

<dom-module id="fotosocial-app">
  <template>
    <style>
      :host {
        display: block;
        --fotosocial-register-container: {
        };
      }
      
    </style>
    <dom-if if="[[_activeElement('fotosocialLogin', activeElement)]]">
      <template>
        <fotosocial-login
          id="fotosocialLogin"
          on-click-go-to-register="_goTo"
          on-click-login="_login">
        </fotosocial-login>
      </template>
    </dom-if>
    <dom-if if="[[_activeElement('fotosocialRegister', activeElement)]]">
      <template>
        <fotosocial-register
          id="fotosocialRegister"
          on-click-go-to-login="_goTo"
          on-click-register="_register">
        </fotosocial-register>
      </template>
    </dom-if>
    <dom-if if="[[_activeElement('fotosocialDashboard', activeElement)]]">
      <template>
        <fotosocial-dashboard on-log-out="_logout" user="[[activeUser]]"></fotosocial-dashboard>
      </template>
    </dom-if>
    <fotosocial-login-dm on-found-user="_searchUser" id="loginDm"></fotosocial-login-dm>
    <fotosocial-user-register-dm
      on-user-already-registered="_userAlreadyRegistered"
      on-user-successfully-registered="_userSuccessfullyRegistered"
      id="userRegisterDm">
    </fotosocial-user-register-dm>
    <paper-dialog id="modalSuccessfully" modal>
      <p>Usuario registrado exitosamente.</p>
      <div class="buttons">
        <paper-button dialog-confirm autofocus on-click="_goToLogin">Aceptar</paper-button>
      </div>
    </paper-dialog>
  </template>

  <script>
    /**
     * @customElement
     * @polymer
     */
    class FotosocialApp extends Polymer.Element {
      static get is() { return 'fotosocial-app'; }
      static get properties() {
        return {
          activeElement: {
            type: String,
            value: 'fotosocialLogin'
          },
          activeUser: {
            type: String,
            value: ''
          }
        };
      }

      _activeElement(element, activeElement) {
        return element === activeElement;
      } 
      
      _goTo(e) {
        this.set('activeElement', e.detail);
      }

      _goToLogin() {
        this._goTo({ detail: 'fotosocialLogin'});
      }

      _logout() {
        this._goToLogin();
      }

      _register(e) {
        this.$.userRegisterDm.set('user', e.detail);
        this.$.userRegisterDm.saveUserLocalStorage();
      }

      _userAlreadyRegistered(e) {
        this.shadowRoot.querySelector('#fotosocialRegister').set('userExist', false);
        this.shadowRoot.querySelector('#fotosocialRegister').set('user', '');
        this.shadowRoot.querySelector('#fotosocialRegister').set('password', '');
        this.shadowRoot.querySelector('#fotosocialRegister').set('passwordConfirm', '');
      }

      _userSuccessfullyRegistered(e) {
        this.$.modalSuccessfully.open();
      }
  
      _login(e) {
        this.$.loginDm.set('user', e.detail);
        this.$.loginDm.searchUser();
      }

      _searchUser(e) {
        if (e.detail) {
          this.set('activeUser', this.shadowRoot.querySelector('#fotosocialLogin').get('user'));
          let objFotosocialDashboard = { detail: 'fotosocialDashboard' };
          this._goTo(objFotosocialDashboard);
        } else {
          this.shadowRoot.querySelector('#fotosocialLogin').set('invalidUser', false);
          this.shadowRoot.querySelector('#fotosocialLogin').set('user', '');
          this.shadowRoot.querySelector('#fotosocialLogin').set('password', '');
        }

      }
    }

    window.customElements.define(FotosocialApp.is, FotosocialApp);
  </script>
</dom-module>
